<template>
  <v-card title="Emitir Mensaje" class="ma-2 pa-2" height="100%" width="100%">
    <v-divider />
    <v-form class="ma-2">
      <v-text-field v-model="titulo" label="Titulo" :rules="tituloRules" />
      <v-text-field
        v-model="contenido"
        label="Contenido"
        :rules="contenidoRules"
      />
      <v-select
        v-model="prioridad"
        label="Prioridad"
        :items="['normal', 'alta', 'emergencia']"
      />
      <v-btn icon="mdi-multicast" @click="send()" />
    </v-form>
  </v-card>
</template>

<script setup lang="ts">
import { Ref, ref } from "vue";
import { backendCollector } from "../../../data/collectors/backendCollector";
import { ChatRoom } from "../../../data/models/ChatRoom";

const props = defineProps({
  materiaId: {
    required: true,
    type: String,
  },
});

const emit = defineEmits<{
  (event: "enviado"): void;
}>();

const titulo = ref("");
const tituloRules = ref([
  (value: string) => {
    if (value?.length > 3) return true;
    return "El titulo debe contener mas de 3 caracteres";
  },
]);

const contenido = ref("");
const contenidoRules = ref([
  (value: string) => {
    if (value?.length > 255) {
      return "El contenido puede ser hasta 255 caracteres";
    }
    return true;
  },
]);

const prioridad: Ref<"normal" | "alta" | "emergencia"> = ref("normal");

function formInvalido() {
  if (
    tituloRules.value[0](titulo.value) != true ||
    contenidoRules.value[0](contenido.value) != true
  ) {
    return true;
  }
  return false;
}
async function send() {
  if (formInvalido()) {
    alert("Form invalido");
  } else {
    const mensaje: ChatRoom["mensajes"][number] = {
      emisor: backendCollector.server.username!,
      titulo: titulo.value,
      timestamp: new Date().toISOString(),
      contenido: contenido.value,
      prioridad: prioridad.value,
    };
    const enviado = await backendCollector.server.postMensaje(
      props.materiaId,
      mensaje
    );
    if (!enviado.success) {
      alert(enviado.code == 403 ? "no autorizado" : "error al enviar mensaje");
    } else {
      alert("mensaje enviado");
      window.location.reload();
    }
  }
}
</script>
